/* ***********************************************************
 * This file was automatically generated on 2019-01-29.      *
 *                                                           *
 * Rust Bindings Version 2.0.8                               *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

//! Generates configurable DC voltage between 0V and 12V.
//!
//! See also the documentation [here](https://www.tinkerforge.com/en/doc/Software/Bricklets/AnalogOutV2_Bricklet_Rust.html).
use crate::{byte_converter::*, converting_receiver::ConvertingReceiver, device::*, ip_connection::IpConnection};
pub enum AnalogOutV2BrickletFunction {
    SetOutputVoltage,
    GetOutputVoltage,
    GetInputVoltage,
    GetIdentity,
}
impl From<AnalogOutV2BrickletFunction> for u8 {
    fn from(fun: AnalogOutV2BrickletFunction) -> Self {
        match fun {
            AnalogOutV2BrickletFunction::SetOutputVoltage => 1,
            AnalogOutV2BrickletFunction::GetOutputVoltage => 2,
            AnalogOutV2BrickletFunction::GetInputVoltage => 3,
            AnalogOutV2BrickletFunction::GetIdentity => 255,
        }
    }
}

#[derive(Clone, Debug, Default, PartialEq, Eq, Hash)]
pub struct Identity {
    pub uid: String,
    pub connected_uid: String,
    pub position: char,
    pub hardware_version: [u8; 3],
    pub firmware_version: [u8; 3],
    pub device_identifier: u16,
}
impl FromByteSlice for Identity {
    fn bytes_expected() -> usize { 25 }
    fn from_le_byte_slice(bytes: &[u8]) -> Identity {
        Identity {
            uid: <String>::from_le_byte_slice(&bytes[0..8]),
            connected_uid: <String>::from_le_byte_slice(&bytes[8..16]),
            position: <char>::from_le_byte_slice(&bytes[16..17]),
            hardware_version: <[u8; 3]>::from_le_byte_slice(&bytes[17..20]),
            firmware_version: <[u8; 3]>::from_le_byte_slice(&bytes[20..23]),
            device_identifier: <u16>::from_le_byte_slice(&bytes[23..25]),
        }
    }
}

/// Generates configurable DC voltage between 0V and 12V
#[derive(Clone)]
pub struct AnalogOutV2Bricklet {
    device: Device,
}
impl AnalogOutV2Bricklet {
    pub const DEVICE_IDENTIFIER: u16 = 256;
    pub const DEVICE_DISPLAY_NAME: &'static str = "Analog Out Bricklet 2.0";
    /// Creates an object with the unique device ID `uid`. This object can then be used after the IP Connection `ip_connection` is connected.
    pub fn new(uid: &str, ip_connection: &IpConnection) -> AnalogOutV2Bricklet {
        let mut result = AnalogOutV2Bricklet { device: Device::new([2, 0, 0], uid, ip_connection, 0) };
        result.device.response_expected[u8::from(AnalogOutV2BrickletFunction::SetOutputVoltage) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(AnalogOutV2BrickletFunction::GetOutputVoltage) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(AnalogOutV2BrickletFunction::GetInputVoltage) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(AnalogOutV2BrickletFunction::GetIdentity) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result
    }

    /// Returns the response expected flag for the function specified by the function ID parameter.
    /// It is true if the function is expected to send a response, false otherwise.
    ///
    /// For getter functions this is enabled by default and cannot be disabled, because those
    /// functions will always send a response. For callback configuration functions it is enabled
    /// by default too, but can be disabled by [`set_response_expected`](crate::analog_out_v2_bricklet::AnalogOutV2Bricklet::set_response_expected).
    /// For setter functions it is disabled by default and can be enabled.
    ///
    /// Enabling the response expected flag for a setter function allows to detect timeouts
    /// and other error conditions calls of this setter as well. The device will then send a response
    /// for this purpose. If this flag is disabled for a setter function then no response is send
    /// and errors are silently ignored, because they cannot be detected.
    ///
    /// See [`set_response_expected`](crate::analog_out_v2_bricklet::AnalogOutV2Bricklet::set_response_expected) for the list of function ID constants available for this function.
    pub fn get_response_expected(&mut self, fun: AnalogOutV2BrickletFunction) -> Result<bool, GetResponseExpectedError> {
        self.device.get_response_expected(u8::from(fun))
    }

    /// Changes the response expected flag of the function specified by the function ID parameter.
    /// This flag can only be changed for setter (default value: false) and callback configuration
    /// functions (default value: true). For getter functions it is always enabled.
    ///
    /// Enabling the response expected flag for a setter function allows to detect timeouts and
    /// other error conditions calls of this setter as well. The device will then send a response
    /// for this purpose. If this flag is disabled for a setter function then no response is send
    /// and errors are silently ignored, because they cannot be detected.
    pub fn set_response_expected(
        &mut self,
        fun: AnalogOutV2BrickletFunction,
        response_expected: bool,
    ) -> Result<(), SetResponseExpectedError> {
        self.device.set_response_expected(u8::from(fun), response_expected)
    }

    /// Changes the response expected flag for all setter and callback configuration functions of this device at once.
    pub fn set_response_expected_all(&mut self, response_expected: bool) { self.device.set_response_expected_all(response_expected) }

    /// Returns the version of the API definition (major, minor, revision) implemented by this API bindings.
    /// This is neither the release version of this API bindings nor does it tell you anything about the represented Brick or Bricklet.
    pub fn get_api_version(&self) -> [u8; 3] { self.device.api_version }

    /// Sets the voltage in mV. The possible range is 0V to 12V (0-12000).
    pub fn set_output_voltage(&self, voltage: u16) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 2];
        payload[0..2].copy_from_slice(&<u16>::to_le_byte_vec(voltage));

        self.device.set(u8::from(AnalogOutV2BrickletFunction::SetOutputVoltage), payload)
    }

    /// Returns the voltage as set by [`set_output_voltage`].
    ///
    /// [`set_output_voltage`]: #method.set_output_voltage
    pub fn get_output_voltage(&self) -> ConvertingReceiver<u16> {
        let payload = vec![0; 0];

        self.device.get(u8::from(AnalogOutV2BrickletFunction::GetOutputVoltage), payload)
    }

    /// Returns the input voltage in mV.
    pub fn get_input_voltage(&self) -> ConvertingReceiver<u16> {
        let payload = vec![0; 0];

        self.device.get(u8::from(AnalogOutV2BrickletFunction::GetInputVoltage), payload)
    }

    /// Returns the UID, the UID where the Bricklet is connected to,
    /// the position, the hardware and firmware version as well as the
    /// device identifier.
    ///
    /// The position can be 'a', 'b', 'c' or 'd'.
    ///
    /// The device identifier numbers can be found [here](device_identifier).
    /// |device_identifier_constant|
    pub fn get_identity(&self) -> ConvertingReceiver<Identity> {
        let payload = vec![0; 0];

        self.device.get(u8::from(AnalogOutV2BrickletFunction::GetIdentity), payload)
    }
}
